<template>
  <q-dialog
    v-model="popupFullSize"
    persistent
    :maximized="maximizedToggle"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
  >
    <q-card class="">
      <q-bar>
        <q-space />
        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggle = false"
          :disable="!maximizedToggle"
        >
          <q-tooltip v-if="maximizedToggle" class="bg-white text-primary"
            >Minimize</q-tooltip
          >
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggle = true"
          :disable="maximizedToggle"
        >
          <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary"
            >Maximize</q-tooltip
          >
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="text-h6">{{ windowObj.title }}</div>
      </q-card-section>
      <q-card-section class="q-pt-none">
        <div class="createAccount">
          <p>si un champ est vide, l'ancienne valeur sera gardé.</p>
          <form class="bottom_forms__child" action="">
            valeur initiale: {{ userObject?.userName }}
            <q-input filled v-model="form.updateAccountName" label="Name" />
            <br />
            valeur initiale: {{ userObject?.mail }}
            <q-input
              filled
              v-model="form.updateAccountMail"
              label="e-mail"
              type="email"
            />
            <br />
            valeur initiale: {{ userObject?.comment }}
            <q-input
              filled
              v-model="form.updateAccountComment"
              label="commentaires"
            />
            <br />
            <q-btn
              @click.prevent="modifUser"
              label="enregistrer"
              type="submit"
              color="primary"
              icon="save_as"
            />
          </form>
        </div>
        <div class="modifyPass">
          <h6>modifier le mot de passe</h6>
          <form class="bottom_forms__child" action="">
            <q-input
              filled
              v-model="form.updateAccountPassOld"
              label="mot de passe actuel"
              type="password"
            />
            <br />
            <q-input
              filled
              v-model="form.updateAccountPassNew"
              label="nouveau mot de passe"
              type="password"
            />
            <br />
            <q-input
              filled
              v-model="form.updateAccountPassNewVerify"
              label="verification du nouveau mot de passe"
              type="password"
            />
            <br />
            <q-btn
              @click.prevent="modifUserPass"
              label="enregistrer"
              type="submit"
              color="primary"
              icon="save_as"
            />
          </form>
        </div>
        <div class="deleteUser">
          <h6>supprimer le compte</h6>
          <form class="bottom_forms__child" action="">
            <q-btn
              @click.prevent="supprUser"
              label="supprimer le compte"
              type="submit"
              color="negative"
              icon="delete"
            />
          </form>
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>
import { defineComponent, ref } from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import { useAuthStore } from 'src/stores/authStore.js';
import { useRouter } from 'vue-router';

export default defineComponent({

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
    userObject: {
      type: Object,
      required: true,
    },
  },

  emits: [
    ...useDialogPluginComponent.emits,
  ],

  setup(props) {
    const router = useRouter();
    const authStore = useAuthStore();
    const form = ref({
      updateAccountPassOld: '',
      updateAccountPassNew: '',
      updateAccountPassNewVerify: '',
      /* updateAccountName: '',
      updateAccountMail: '',
      updateAccountComment: '', */
    });
    const popupFullSize = ref(true);
    const {
      dialogRef,
      onDialogHide,
    } = useDialogPluginComponent();
    const quasar = useQuasar();
    const maximizedToggle = ref(true);

    const modifUser = () => {
      const bodyRequest = {};
      bodyRequest.userName = form.value.updateAccountName;
      bodyRequest.mail = form.value.updateAccountMail;
      bodyRequest.comment = form.value.updateAccountComment;
      console.log(bodyRequest);
      if (bodyRequest.userName === ('' || undefined)) {
        bodyRequest.userName = props.userObject.value.userName;
        console.log(props.userObject.value.userName);
      }
      if (bodyRequest.mail === ('' || undefined)) {
        bodyRequest.mail = props.userObject.value.mail;
        console.log(props.userObject.value.mail);
      }
      if (bodyRequest.comment === ('' || undefined)) {
        bodyRequest.comment = props.userObject.value.comment;
        console.log(props.userObject.value.comment);
      }
      const requestOptionsConn = {
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json',
          Authorization: `Bearer ${authStore.jwt}`,
        },
        body: JSON.stringify({
          userName: bodyRequest.userName,
          mail: bodyRequest.mail,
          comment: bodyRequest.comment,
        }),
      };

      quasar.dialog({
        title: 'Confirm',
        message: 'êtes vous sur de vouloir appliquer les modifications?',
        cancel: true,
      }).onOk(() => {
        fetch(`${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}`, requestOptionsConn)
          .then((response) => {
            response.json();
            if (response.status !== 200) {
              quasar.dialog({
                title: 'Alert',
                message: 'un problème est survenu ...',
              });
              throw response.status;
            }
            try {
              console.log(response);
              authStore.userObject.userName = bodyRequest.userName;
              authStore.userObject.mail = bodyRequest.mail;
              authStore.userObject.comment = bodyRequest.comment;
              form.value.updateAccountName = '';
              form.value.updateAccountMail = '';
              form.value.updateAccountComment = '';
              popupFullSize.value = false;
              quasar.notify({
                message: 'Les modifications ont été appliqués',
                color: 'positive',
                badgeTextColor: 'white',
                progress: true,
              });
            } catch (e) {
              console.log('error - no valid response');
              console.log(e);
            }
          });
      });
    };

    const modifUserPass = () => {
      const bodyRequest = {};
      bodyRequest.passOld = form.value.updateAccountPassOld;
      bodyRequest.passNew = form.value.updateAccountPassNew;
      bodyRequest.passNewVerify = form.value.updateAccountPassNewVerify;
      if (bodyRequest.passNew !== bodyRequest.passNewVerify) {
        quasar.notify({
          message: 'les 2 versions du nouveau mot de passe diffèrent',
          color: 'negative',
          badgeTextColor: 'white',
          progress: true,
        });
        return false;
      }
      const requestOptionsConn = {
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json',
          Authorization: `Bearer ${authStore.jwt}`,
        },
        body: JSON.stringify({
          newPass: bodyRequest.passNew,
          oldPass: bodyRequest.passOld,
        }),
      };
      quasar.dialog({
        title: 'Confirm',
        message: 'êtes vous sur de vouloir appliquer les modifications?',
        cancel: true,
      }).onOk(() => {
        fetch(
          `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/pass`,
          requestOptionsConn,
        )
          .then((response) => {
            response.json();
            if (response.status !== 200) {
              quasar.dialog({
                title: 'Alert',
                message: 'un problème est survenu ...',
              });
              throw response.status;
            }
            try {
              console.log('that is try');
              console.log(response);/*
              authStore.userObject.userName = bodyRequest.userName;
              authStore.userObject.mail = bodyRequest.mail;
              authStore.userObject.comment = bodyRequest.comment; */
              authStore.userObject = bodyRequest;
              form.value = { updateAccountPassOld: '', updateAccountPassNew: '', updateAccountPassNewVerify: '' };
              // authStore.updateUserObject(authStore.userObject);
              popupFullSize.value = false;
              quasar.notify({
                message: 'Les modifications ont été appliqués',
                color: 'positive',
                badgeTextColor: 'white',
                progress: true,
              });
              window.location.reload();
            } catch (e) {
              console.log('error - no valid response');
              console.log(e);
            }
          });
      });
    };

    const supprUser = () => {
      quasar.dialog({
        title: 'Confirmation',
        message: 'Cette opération est irréversible! souhaitez-vous continuer le processus de destruction de ce compte et des données qu\'il contiens?',
        cancel: true,
      }).onOk(() => {
        const verifString = 'je comprend le caractère définitif de la démarche';
        quasar.dialog({
          title: 'Confirmation',
          message: `Pour éviter toute mauvaise manipulation, écrivez "${verifString}"`,
          prompt: {
            model: '',
            type: 'text',
          },
          persistent: true,
          cancel: true,
        }).onOk((data) => {
          if (data !== verifString) {
            quasar.notify({
              message: 'mauvaise phrase de confirmation',
              color: 'negative',
              badgeTextColor: 'white',
              progress: true,
            });
            return false;
          }
          const requestOptionsConn = {
            method: 'DELETE',
            headers: {
              Authorization: `Bearer ${authStore.jwt}`,
            },
          };
          fetch(`${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}`, requestOptionsConn)
            .then((response) => {
              response.json();
              if (response.status !== 200) {
                quasar.dialog({
                  title: 'Alert',
                  message: 'un problème est survenu ...',
                });
                throw response.status;
              }
              try {
                console.log('good for delete request:');
                console.log(response);
                authStore.logout();
                router.push('/');
                popupFullSize.value = false;
                quasar.notify({
                  message: 'votre compte a été définitivement supprimer',
                  color: 'positive',
                  badgeTextColor: 'white',
                  progress: true,
                });
              } catch (e) {
                console.log('error - no valid response');
                console.log(e);
              }
            });
        });
      });
    };

    return {
      dialogRef,
      onDialogHide,
      maximizedToggle,
      modifUser,
      modifUserPass,
      supprUser,
      form,
      popupFullSize,
      ...props,
    };
  },
});
</script>
